;###############################################################################
/* Control for LilBuilder

*/
;###############################################################################

Control_CreateNew(Type, GuiHWND){
   Static CtrlCnt = 0, PrevCtrlType

   CtrlCnt++
   GuiID := Gui(GuiHWND, "GuiID")

   Content := Type " Control " CtrlCnt
   If Type = Picture
      Content := A_WinDir "\Notepad.exe"
   Else If Type = Tab
   {
      TabCnt := Gui(GuiHWND, "TabCount")
      TabCnt := TabCnt ? ++TabCnt : 1
      Gui(GuiHWND, "TabCount", TabCnt)
      Content = Tab%TabCnt%.1|Tab%TabCnt%.2
      SpecialOption = AltSubmit
   }
   Else If (Type = "UpDown" and PrevCtrlType <> "Edit")
      SpecialOption = -16      ;isolate UpDown
   PrevCtrlType = %Type%
   
   StandardCtrls := ToolBox_StandardCtrls()
   if Type in %StandardCtrls%
   {
      VarName = New%CtrlCnt%
      CtrlHWND := 0 + Control_CreateControl(GuiID, Type, SpecialOption " x0 y0 v" VarName, Content)
      StandardControl := True
   }
   else {
      if Type = HiEdit
         CtrlHWND := 0 + HE_Add(GuiHWND, 0, 0, 300, 200)

      else if Type = HLink
         CtrlHWND := 0 + HLink_Add(GuiHWND, "Click <a href=""http://www.Google.com"">here</a>", 0, 0, 80, 20)

      else if Type = RaGrid
      {
         RG_Init()
         CtrlHWND := 0 + RG_Add(GuiHWND, 0, 0, 220, 150, STYLE_VGRIDLINES | STYLE_GRIDLINES )
         RG_AddColumn(CtrlHWND, "cap=Col1", "w=150" )
         RG_AddColumn(CtrlHWND, "cap=Col2", "w=50")
         RG_SetHdrHeight(CtrlHWND, 25)
      }

      else if Type = IE
      {
         pwb := IE_Add(GuiHWND, 0, 0, 200, 200)
         IE_LoadHTML(pwb, "<a href=""http://www.autohotkey.com/forum/viewtopic.php?t=19225&start=0"">IE Control</a>")
      }
   }
  Control(CtrlHWND,"Create")
  Control(CtrlHWND,"Type",Type)
  If StandardControl {
    Control(CtrlHWND,"VarName",VarName)
    Control(CtrlHWND,"Content",Content)
    If Type = Tab
    {
      Gui, %GuiID%:Tab ;by default no controls get added to tab
      Control(CtrlHWND,"TabID",TabCnt)
      Control(CtrlHWND "T1","Create")         ;create tab page controls as subcontrols of tabs to hold controls
      Control(CtrlHWND "T1","Type","TabPage")
      Control(CtrlHWND "T2","Create")
      Control(CtrlHWND "T2","Type","TabPage")
    }
  }
  Else {

  }

  If (TabPageHWND := Tab_AddCtrl2Page())
    Tab_AddControl2Page(TabPageHWND, CtrlHWND)
  Else
    Gui_AddControl(GuiHWND,CtrlHWND)          ;add control to list of controls on gui

  Return CtrlHWND
}

;create a control in a global context
Control_CreateControl(GuiID, Type, Options, Content){
  local CtrlHWND
  Gui, %GuiID%:Add, %Type%, %Options%  HWNDCtrlHWND, %Content%
  Return CtrlHWND
}

;set a property and remove others simulatiously
Control_ExchangeProperties(CtrlHWND, PropertyName, NewValue, ValuesToRemove){
  Property := Control(CtrlHWND,PropertyName)
  Loop, Parse, ValuesToRemove, `,
      Property := RegExReplace(Property, "\b" A_LoopField "\b")
  Control(CtrlHWND,PropertyName, Property . NewValue)
}

Control(HWND,PropertyNameOrAction,Value=""){
  Static MasterDic, init = 0

  If !init {  ;set up a master dic once to link HWNDs to their pDic
    init++
    MasterDic := Dic("insensitive")
  }

  If (HWND = "Remove" And PropertyNameOrAction = "All")  ;delete all dics
  {
    Loop{                                                ;delete all control dics
      If (HWND := Dic_NextKey(penum, MasterDic))
        Dic("delete", Dic_Get(MasterDic, HWND))
      If !penum
        Break
    }
    Dic("delete",MasterDic)                              ;delete master dic
    init = 0                                             ;reset init state
  }

  Else If PropertyNameOrAction = Remove   ;remove dic for control
  {
    Dic("delete", Dic_Get(MasterDic, HWND))    ;delete the dic for the control
    Dic_Remove(MasterDic, HWND)                ;remove dic from master dic
  }

  Else If PropertyNameOrAction = Create  ;create a dic for control
  { ;store pDic of dic in master list under the HWND key
    Dic_Set(MasterDic, HWND, Dic("insensitive"))
  }

  Else If Value   ;assign value
  { ;get pDic from master dic and assign value
    Dic_Set(Dic_Get(MasterDic, HWND), PropertyNameOrAction, Value)
  }

  Else ;return value
  { ;get pDic from master dic and return value
    Return Dic_Get(Dic_Get(MasterDic, HWND), PropertyNameOrAction)
  }
  Return 1
}

