;###############################################################################
/* Gui for LilBuilder

*/
;###############################################################################

Gui_Create() {
  local GuiHWND
  static GuiCnt = 9     ;start user guis with id 10, which leave 9 guis for the builder

  GuiCnt++
  Gui, %GuiCnt%:+LastFound +Resize +LabelGui_
  GuiHWND := WinExist() + 0
  WinSet, Trans, 255, ahk_id %GuiHWND%
  WinSet, Trans, 255
  Gui, %GuiCnt%:Show, w550 h610, %ScriptName% - r%SVN_RevNum% %SVN_RevDate%
;   Gui, %GuiCnt%:Add,Picture, x0 y0 vGrid%GuiHWND%, res\grid.gif
  Gui(GuiHWND,"Create")
  Gui(GuiHWND,"Resize", 1)
  Gui(GuiHWND,"GuiID", GuiCnt)
  Project_AddUserGUI(GuiHWND)
  Selector_SelGuiHWND(GuiHWND)
}

Gui_Close:
  ExitApp
return

Gui_Refresh:
  DllCall("InvalidateRect", "uint", Selector_SelGuiHWND(), "uint", 0, "uint", 0)
  DllCall("UpdateWindow", "uint", Selector_SelGuiHWND())
  Grid_Draw()
return

Gui_Size:
  Grid_Draw()
Return

Gui_AddControl(GuiHWND,CtrlHWND){
  OrderOfControls := Gui(GuiHWND,"OrderOfControls") "," CtrlHWND
  Gui(GuiHWND,"OrderOfControls",OrderOfControls)
}

Gui(HWND,PropertyNameOrAction,Value=""){
  Static MasterDic, init = 0

  If !init {  ;set up a master dic once to link HWNDs to their pDic
    init++
    MasterDic := Dic("insensitive")
  }

  If (HWND = "Remove" And PropertyNameOrAction = "All")  ;delete all dics
  {
    Loop{                                                ;delete all Gui dics
      If (HWND := Dic_NextKey(penum, MasterDic))
        Dic("delete", Dic_Get(MasterDic, HWND))
      If !penum
        Break
    }
    Dic("delete",MasterDic)                              ;delete master dic
    init = 0                                             ;reset init state
  }

  Else If PropertyNameOrAction = Remove   ;remove dic for Gui
  {
    Dic("delete", Dic_Get(MasterDic, HWND))    ;delete the dic for the Gui
    Dic_Remove(MasterDic, HWND)                ;remove dic from master dic
  }

  Else If PropertyNameOrAction = Create  ;create a dic for Gui
  { ;store pDic of dic in master list under the HWND key
    Dic_Set(MasterDic, HWND, Dic("insensitive"))
  }

  Else If Value   ;assign value
  { ;get pDic from master dic and assign value
    Dic_Set(Dic_Get(MasterDic, HWND), PropertyNameOrAction, Value)
  }

  Else ;return value
  { ;get pDic from master dic and return value
    Return Dic_Get(Dic_Get(MasterDic, HWND), PropertyNameOrAction)
  }
  Return 1
}
