;###############################################################################
/* Selector for LilBuilder

*/
;###############################################################################

Selector_GuiID(){
  Return 1
}

Selector_HWND(NewHWND=""){                  ;selectors own gui
  static HWND
  If NewHWND
     HWND = %NewHWND%
  Return %HWND%
}

Selector_SelCtrlHWND(NewHWND=""){              ;currently selected control
  static HWND
  If NewHWND = No
     HWND =
  Else If NewHWND
     HWND = %NewHWND%
  Return %HWND%
}

Selector_SelGuiHWND(NewHWND=""){               ;currectly active user gui
  static HWND
  If NewHWND = No                           ;there should normally always be one
     HWND =
  Else If NewHWND
     HWND = %NewHWND%
  Return %HWND%
}

Selector_Create() {
   local Selector_GuiID
   Selector_GuiID := Selector_GuiID()
   Gui, %Selector_GuiID%:+LastFound -Caption +Resize +ToolWindow +LabelSelector_ ;AlwaysOnTop
   Gui, %Selector_GuiID%:Color, FFFF
   WinSet, Transparent, 100
   Selector_HWND(WinExist())
}

Selector_Size:
  Selector_Size()
return
Selector_Size(UpdateState=""){
  static Update := True
  If UpdateState is not space
    Return Update := UpdateState
  If !Update     ;don't resize when Selector is set 2 Ctrl
    Return Update
  If (GRID() AND !GetKeyState("LControl")){
    Selector_UpdateCtrlwGrid()
    SetTimer, Selector_UpdateItself, 100
  }
  else Selector_UpdateCtrl()
}

Selector_Set2Ctrl(){
   Selector_GuiID := Selector_GuiID()
   Selector_Size(False)
   WinGetPos, ux, uy,,, % "ahk_id " Selector_SelGuiHWND()
   ControlGetPos, sx,sy,sw,sh,, % "ahk_id " Selector_SelCtrlHWND()
   WinMove, % "ahk_id " Selector_HWND(), ,sx + ux, sy + uy, sw, sh
   Gui, %Selector_GuiID%:Show
   WinActivate, % "ahk_id " Selector_HWND()
   Sleep, 50     ;needed, otherwise Selector_Size() doesn't get False state
   Selector_Size(True)
}

; Update control to match cursor's size and position
Selector_UpdateCtrl(){
   WinGetPos, ux, uy,,, % "ahk_id " Selector_SelGuiHWND()
   WinGetPos, sx,sy,sw,sh, % "ahk_id " Selector_HWND()
   ControlMove,, sx-ux, sy-uy, sw, sh, % "ahk_id " Selector_SelCtrlHWND()
   SetTimer, Gui_Refresh, -500
}

Selector_UpdateItself:
  If !GetKeyState("LButton"){
      SetTimer, Selector_UpdateItself, Off
      Selector_Set2Ctrl()
      Grid_Draw() ; Update When Snap to grid
  }
Return

Selector_UpdateCtrlwGrid(Type="") {
   WinGetPos, ux, uy, , , % "ahk_id " Selector_SelGuiHWND()
   WinGetPos, cx, cy ,cw, ch, % "ahk_id " Selector_HWND()
   cx -= ux, cy -= uy ;relative position
   GRID := Grid()
   dx := Mod(cx, GRID), dy := Mod(cy, GRID)    ;snap to grid
   dx -= (dx ? GRID : 0),cx -= dx, dy -= (dy ? GRID : 0),cy -= dy
   If !(Type = "PositionOnly"){
      dw := Mod(cw, GRID), dh := Mod(ch, GRID)   ;snap to grid
      cw -= (cw > dw ? dw : 0), ch -= (ch > dh ? dh : 0)
   }
   ControlMove,,cx,cy,cw,ch, % "ahk_id " Selector_SelCtrlHWND()
}

Selector_OnDelete:
   DllCall("DestroyWindow", "uint", Selector_SelCtrlHWND())
   WinActivate, % "ahk_id " Selector_SelGuiHWND()      ;hide the cursor besides
   Grid_Draw() ; Update When control deleted
return

; Selector_Hide() {    ;??? not used
;    global
;    Selector_SelCtrlHWND("No")
;    WinHide, % "ahk_id " Selector_HWND()
;    Grid_Draw()
; }
